<?php
  //----------------------------------------------------------------------
  // JBudgetsMagic
  // JBudgetsMagic by Fernando Hidalgo - http://joomlamagic.es
  //----------------------------------------------------------------------

  //----------------------------------------------------------------------
  // Author: 	Fernando Hidalgo - http://joomlamagic.es
  // Copyright: copyright (C) 2009 - Fernando Hidalgo.
  // License: 	GNU/GPL, http://www.gnu.org/copyleft/gpl.html
  // Pack: 	JBudgetsMagic
  // File: 	budget.php
  //----------------------------------------------------------------------  
  
  //----------------------------------------------------------------------    
  // JBudgetsMagic is free software. This version may have been modified pursuant
  // to the GNU General Public License, and as distributed it includes or
  // is derivative of works licensed under the GNU General Public License or
  // other free or open source software licenses.  
  //----------------------------------------------------------------------


defined( '_JEXEC' ) or die( 'Restricted access' );

class bdgControllerbudget extends bdgController
{
	function __construct()
	{
		parent::__construct();
		// Register Extra tasks
		$this->registerTask( 'add'  , 	'edit' );
		$this->registerTask( 'unpublish', 	'publish');
		$this->cid = JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger($this->cid, array(0));
	}
	function _buildQuery()
	{
		$this->_query = 'UPDATE #__bdg_budgets'
		. ' SET published = ' . (int) $this->publish
		. ' WHERE id IN ( '. $this->cids .' )'		
		;
		return $this->_query;     
	}
	function edit()
	{
		JRequest::setVar( 'view', 'budget' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);
		parent::display();
	}

	function cancel()
	{
		$msg = JText::_( 'COM_JBUDGETSMAGIC_OPERATION_CANCELLED' );
		$this->setRedirect( 'index.php?option=com_jbudgetsmagic&view=budgets', $msg );
	}
	
	function save_revision()
	{
		//$data	= JRequest::get('post');
		$bid = JRequest::getVar('bid');
		$revision['budget_id']	= $bid;
		$revision['revision_num'] = JRequest::getVar('revisions');
		$revision['upload'] = JFactory::getDate()->toMySQL();
		$revision['notes']	= JRequest::getVar( 'notes', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$revision['price'] = JRequest::getVar('total');
		
		$model = $this->getModel( 'budget' );
		$el_ori = $model->getElements($bid, 0);

		$elements = array();
		for ($i = 0; $i < count($el_ori); $i++) {
			$id = $el_ori[$i]->element_id;
			$element =& JTable::getInstance('budgets_elements', 'Table');
			$element->budget_id = $bid;
			$element->revision_id = $revision['revision_num'];
			$element->element_id = $id;
			$element->element_title = JRequest::getVar('element_title_'.$id);
			$element->element_description = JRequest::getVar('element_description_'.$id);
			$element->element_type = JRequest::getVar('element_type_'.$id);
			$element->element_amount = JRequest::getVar('element_amount_'.$id);
			$element->element_price = JRequest::getVar('element_price_'.$id);
			$element->element_total = JRequest::getVar('element_total_'.$id);
			$element->store();
		}
		
		if ($model->save_revision($revision,$elements)) {
			$msg = JText::_( 'COM_JBUDGETSMAGIC_REVISION_SAVED' );
		} else {
			$msg = JText::_( 'COM_JBUDGETSMAGIC_ERROR_SAVING_REVISION' );
		}

		$link = 'index.php?option=com_jbudgetsmagic&controller=budget&task=edit&bid='.$bid;
		$this->setRedirect( $link, $msg );
	}
	
	function next_revision()
	{
		$rid = JRequest::getVar('rid',0);
		$bid = JRequest::getVar('bid');
		$revisions = JRequest::getVar('revisions') - 1;
		$rid++;
		if ($rid < $revisions)
			$msg = JText::_('COM_JBUDGETSMAGIC_YOU_ARE_AT_REVISION').' '.$rid;
		else
			$msg = JText::_('COM_JBUDGETSMAGIC_YOU_ARE_AT_LAST_REVISION').' '.$rid;
		$link = 'index.php?option=com_jbudgetsmagic&controller=budget&task=edit&bid='.$bid.'&rid='.$rid;
		$this->setRedirect( $link, $msg );
	}
	
	function prev_revision()
	{
		$rid = JRequest::getVar('rid',0);
		$bid = JRequest::getVar('bid');
		$rid--;
		if ($rid <> 0)
			$msg = JText::_('COM_JBUDGETSMAGIC_YOU_ARE_AT_REVISION').' '.$rid;
		else
			$msg = JText::_('COM_JBUDGETSMAGIC_YOU_ARE_AT_ORIGINAL_BUDGET');
		$link = 'index.php?option=com_jbudgetsmagic&controller=budget&task=edit&bid='.$bid.'&rid='.$rid;
		$this->setRedirect( $link, $msg );
	}
	
	function last_revision()
	{
		$rid = JRequest::getVar('revisions') - 1;
		$bid = JRequest::getVar('bid');
		$msg = JText::_('COM_JBUDGETSMAGIC_YOU_ARE_AT_LAST_REVISION').' '.$rid;
		$link = 'index.php?option=com_jbudgetsmagic&controller=budget&task=edit&bid='.$bid.'&rid='.$rid;
		$this->setRedirect( $link, $msg );
	}
	
	function add_comment()
	{
		$comment->title = JRequest::getVar('title');
		$comment->description	= JRequest::getVar( 'description', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$bid = JRequest::getVar('bid');
		$link = 'index.php?option=com_jbudgetsmagic&controller=budget&task=edit&bid='.$bid;
		if (($comment->title == "") || ($comment->description == "")) {
			$msg = JText::_('COM_JBUDGETSMAGIC_TITLE_AND_DESCRIPTION_FIELDS_IN_NEW_COMMENT_ARE_REQUIRED');
		} else {
			$comment->upload = JFactory::getDate()->toMySQL();
			$user = &JFactory::getUser();
			$comment->user_id = $user->id;
			$comment->budget_id = $bid;
			$model = $this->getModel( 'budget' );
			if ($model->save_comment($comment)) {
				$msg = JText::_( 'COM_JBUDGETSMAGIC_COMMENT_SAVED' );
			} else {
				$msg = JText::_( 'COM_JBUDGETSMAGIC_ERROR_SAVING_COMMENT' );
			}			
		}
		$this->setRedirect($link, $msg);
	}
	
	function remove()
	{
		$model = $this->getModel('budget');
		if(!$model->delete()) {
			$msg = JText::_( 'COM_JBUDGETSMAGIC_ERROR_DELETING_BUDGET' );
		} else {
			$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
			foreach($cids as $cid) {
				$msg .= JText::_('COM_JBUDGETSMAGIC_BUDGET_DELETED').': '.$cid.' ';
			}			
		}

		$this->setRedirect( 'index.php?option=com_jbudgetsmagic&view=budgets', $msg );
	}
}
