<?php
  //----------------------------------------------------------------------
  // JBudgetsMagic
  // JBudgetsMagic by Fernando Hidalgo - http://joomlamagic.es
  //----------------------------------------------------------------------

  //----------------------------------------------------------------------
  // Author: 	Fernando Hidalgo - http://joomlamagic.es
  // Copyright: copyright (C) 2009 - Fernando Hidalgo.
  // License: 	GNU/GPL, http://www.gnu.org/copyleft/gpl.html
  // Pack: 	JBudgetsMagic
  // File: 	color.php
  //----------------------------------------------------------------------  
  
  //----------------------------------------------------------------------    
  // JBudgetsMagic is free software. This version may have been modified pursuant
  // to the GNU General Public License, and as distributed it includes or
  // is derivative of works licensed under the GNU General Public License or
  // other free or open source software licenses.  
  //----------------------------------------------------------------------


defined( '_JEXEC' ) or die( 'Restricted access' );

class bdgControllercolor extends bdgController
{
	function __construct()
	{
		parent::__construct();
		// Register Extra tasks
		$this->registerTask( 'add'  , 	'edit' );
		$this->registerTask( 'unpublish', 	'publish');

		$this->cid = JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger($this->cid, array(0));
	}
	function _buildQuery()
	{
		$this->_query = 'UPDATE #__bdg_colors'
		. ' SET published = ' . (int) $this->publish
		. ' WHERE id IN ( '. $this->cids .' )'		
		;
		return $this->_query;     
	}
	function edit()
	{
		JRequest::setVar( 'view', 'color' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);
		parent::display();
	}

	function cancel()
	{
		$msg = JText::_( 'COM_JBUDGETSMAGIC_OPERATION_CANCELLED' );
		$this->setRedirect( 'index.php?option=com_jbudgetsmagic&view=colors', $msg );
	}
	function publish()
	{
		$cid		= JRequest::getVar( 'cid', array(), '', 'array' );
		$this->publish	= ( $this->getTask() == 'publish' ? 1 : 0 );

		JArrayHelper::toInteger($cid);
		if (count( $cid ) < 1)
		{
			$action = $publish ? 'publish' : 'unpublish';
			JError::raiseError(500, JText::_( 'COM_JBUDGETSMAGIC_SELECT_AN_ITEM_TO_' .$action, true ) );
		}

		$this->cids = implode( ',', $cid );

		$query = $this->_buildQuery();
		$db = &JFactory::getDBO();
		$db->setQuery($query);
		if (!$db->query())
		{
			JError::raiseError(500, $db->getErrorMsg() );
		}
		$link = 'index.php?option=com_jbudgetsmagic&view=colors';
		$this->setRedirect($link, $msg);
	}

	function save()
	{
		$post	= JRequest::get('post');
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$post['id'] 	= (int) $cid[0];
                for ($i = 0; $i < 10; $i++) {
                    eval("$"."post[color".$i."] = str_replace('#','',"."JRequest::getVar('"."color".$i."'));");
                }

		$model = $this->getModel( 'color' );
		if ($model->store($post)) {
			$msg = JText::_( 'COM_JBUDGETSMAGIC_COLOR_SAVED' );
		} else {
			$msg = JText::_( 'COM_JBUDGETSMAGIC_ERROR_SAVING_COLOR' );
		}

		$link = 'index.php?option=com_jbudgetsmagic&view=colors';
		$this->setRedirect( $link, $msg );
	}

	function remove()
	{
		$model = $this->getModel('color');
		if(!$model->delete()) {
			$msg = JText::_( 'COM_JBUDGETSMAGIC_ERROR_DELETING_COLOR' );
		} else {
			$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
			foreach($cids as $cid) {
				$msg .= JText::_( 'COM_JBUDGETSMAGIC_COLOR_DELETED').': '.$cid;
			}			
		}

		$this->setRedirect( 'index.php?option=com_jbudgetsmagic&view=colors', $msg );
	}
}
