<?php
  //----------------------------------------------------------------------
  // JBudgetsMagic
  // JBudgetsMagic by Fernando Hidalgo - http://joomlamagic.es
  //----------------------------------------------------------------------

  //----------------------------------------------------------------------
  // Author: 	Fernando Hidalgo - http://joomlamagic.es
  // Copyright: copyright (C) 2009 - Fernando Hidalgo.
  // License: 	GNU/GPL, http://www.gnu.org/copyleft/gpl.html
  // Pack: 	JBudgetsMagic
  // File: 	element.php
  //----------------------------------------------------------------------  
  
  //----------------------------------------------------------------------    
  // JBudgetsMagic is free software. This version may have been modified pursuant
  // to the GNU General Public License, and as distributed it includes or
  // is derivative of works licensed under the GNU General Public License or
  // other free or open source software licenses.  
  //----------------------------------------------------------------------


defined( '_JEXEC' ) or die( 'Restricted access' );

class bdgControllerelement extends bdgController
{
	//var $cid;
	//var $order;

	function __construct()
	{
		parent::__construct();
		// Register Extra tasks
		$this->registerTask( 'add'  , 	'edit' );
		$this->registerTask( 'unpublish', 	'publish');

		//$this->scope = JRequest::getCmd( 'scope' );
		$this->cid = JRequest::getVar( 'cid', array(0), '', 'array' );
		//$this->order = JRequest::getVar('filter_order_Dir');
		JArrayHelper::toInteger($this->cid, array(0));
	}
	function _buildQuery()
	{
		$this->_query = 'UPDATE #__bdg_types_elements'
		. ' SET published = ' . (int) $this->publish
		. ' WHERE id IN ( '. $this->cids .' )'		
		;
		return $this->_query;     
	}
	function edit()
	{
		JRequest::setVar( 'view', 'element' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);
		parent::display();
	}

	function cancel()
	{
		$msg = JText::_( 'COM_JBUDGETSMAGIC_OPERATION_CANCELLED' );
		$this->setRedirect( 'index.php?option=com_jbudgetsmagic&view=types_elements', $msg );
	}
	function publish()
	{
		$cid		= JRequest::getVar( 'cid', array(), '', 'array' );
		$this->publish	= ( $this->getTask() == 'publish' ? 1 : 0 );

		JArrayHelper::toInteger($cid);
		if (count( $cid ) < 1)
		{
			$action = $publish ? 'publish' : 'unpublish';
			JError::raiseError(500, JText::_( 'COM_JBUDGETSMAGIC_SELECT_AN_ITEM_TO_' .$action, true ) );
		}

		$this->cids = implode( ',', $cid );

		$query = $this->_buildQuery();
		$db = &JFactory::getDBO();
		$db->setQuery($query);
		if (!$db->query())
		{
			JError::raiseError(500, $db->getErrorMsg() );
		}
		$link = 'index.php?option=com_jbudgetsmagic&view=types_elements';
		$this->setRedirect($link, $msg);
	}

	function save()
	{
		$post	= JRequest::get('post');
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$post['id'] 	= (int) $cid[0];

		$model = $this->getModel( 'element' );
		if ($model->store($post)) {
			$msg = JText::_( 'COM_JBUDGETSMAGIC_SAVED' ).'<br>';
		} else {
			$msg = JText::_( 'COM_JBUDGETSMAGIC_ERROR_SAVING' );
		}

		$link = 'index.php?option=com_jbudgetsmagic&view=types_elements';
		$this->setRedirect( $link, $msg );
	}

	function remove()
	{
		$model = $this->getModel('element');
		if(!$model->delete()) {
			$msg = JText::_( 'COM_JBUDGETSMAGIC_ERROR_DELETING' );
		} else {
			$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
			foreach($cids as $cid) {
				$msg .= JText::_( 'COM_JBUDGETSMAGIC_DELETED').': '.$cid.'.&nbsp;&nbsp;&nbsp;';
			}			
		}

		$this->setRedirect( 'index.php?option=com_jbudgetsmagic&view=types_elements', $msg );
	}

	function _reOrder($direction)
	{
		global $mainframe;
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$db		= & JFactory::getDBO();
		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );

		if (isset( $cid[0] ))
		{
			$row = & JTable::getInstance('element', 'Table');
			$row->load( (int) $cid[0] );
			$row->move($direction, 'type_id = ' . (int) $row->type_id );

			$cache = & JFactory::getCache('com_jbudgetsmagic');
			$cache->clean();
		}

		$mainframe->redirect('index.php?option=com_jbudgetsmagic&view=types_elements');
	}

	function saveorder()
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$db =& JFactory::getDBO();
		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );

		$total		= count( $cid );
		$order 		= JRequest::getVar( 'order', array(0), 'post', 'array' );
		JArrayHelper::toInteger($order, array(0));

		$row		=& JTable::getInstance('element', 'Table');
		$groupings = array();
	
		// update ordering values
		for( $i=0; $i < $total; $i++ ) {
			$row->load( (int) $cid[$i] );
			// track sections
			$groupings[] = $row->type_id;
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					JError::raiseError(500, $db->getErrorMsg());
				}
			}
		}
	
		// execute updateOrder for each parent group
		$groupings = array_unique( $groupings );
		foreach ($groupings as $group){
			$row->reorder('type_id = '.$db->Quote($group));
		}
	
		$msg 	= JText::_( 'COM_JBUDGETSMAGIC_NEW_ORDERING_SAVED' );
		$mainframe->redirect('index.php?option=com_jbudgetsmagic&view=types_elements', $msg);
	}	

	function orderup()
	{	
		if ($this->order == 'desc')
			$this->_reOrder(1);
		else
			$this->_reOrder(-1);			
	}

	function orderdown()
	{
		if ($this->order == 'desc')
			$this->_reOrder(-1);
		else
			$this->_reOrder(1);
	}

	function am_elements() {
		$mainframe = &JFactory::getApplication();
		$type_id = JRequest::getVar('type_id');
		$mainframe->redirect('index.php?option=com_jbudgetsmagic&view=am_elements&type_id='.$type_id);
	}

	function save_am() {
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$post	= JRequest::get('post');
		$item_id	= JRequest::getVar('item_id');

		for($i = 0; $i < count($item_id); $i++) {
			$data['id'] 	= (int) $cid[0];
			$data['item_id'] = $item_id[$i];
			$data['type_id'] = $post['type_id'];

			$model = $this->getModel( 'element' );
			if ($model->store($data)) {
				$msg = JText::_( 'COM_JBUDGETSMAGIC_ELEMENT_SAVED' );
			} else {
				$msg = JText::_( 'COM_JBUDGETSMAGIC_ERROR_SAVING_ELEMENT' );
			}
		}
		$link = 'index.php?option=com_jbudgetsmagic&view=types_elements&type_id='.$post['type_id'];
		$this->setRedirect( $link, $msg );				
	}
}
