<?php
  //----------------------------------------------------------------------
  // JBudgetsMagic
  // JBudgetsMagic by Fernando Hidalgo - http://joomlamagic.es
  //----------------------------------------------------------------------

  //----------------------------------------------------------------------
  // Author: 	Fernando Hidalgo - http://joomlamagic.es
  // Copyright: copyright (C) 2009 - Fernando Hidalgo.
  // License: 	GNU/GPL, http://www.gnu.org/copyleft/gpl.html
  // Pack: 	JBudgetsMagic
  // File: 	view.pdf.php
  //----------------------------------------------------------------------  
  
  //----------------------------------------------------------------------    
  // JBudgetsMagic is free software. This version may have been modified pursuant
  // to the GNU General Public License, and as distributed it includes or
  // is derivative of works licensed under the GNU General Public License or
  // other free or open source software licenses.  
  //----------------------------------------------------------------------


defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

class bdgViewmybudget extends JView
{
	function display($tpl = null)
	{
		$verjoomla = new JVersion();

		$user = &JFactory::getUser();
		$uid = $user->id;
		
		$model =& $this->getModel();
		$budget_id = JRequest::getInt('bid');
		$currency = bdgHelperConfig::get_curr();
		$currency_align = bdgHelperConfig::get_curr_align();
		$revisions = $model->getRevisions($budget_id);
		$rev_id = JRequest::getInt('rid', $revisions);
		$budget = $model->getBudget($budget_id);
		$pass = bdgHelperConfig::getConfig('randomkey','set');
		if (($budget->user_id != $uid) && ($pass != JRequest::getString('key') || $pass == 'set'))  {
			JError::raiseError(1, JText::_('Invalid user No access'));
		}
		$elements = $model->getElements($budget_id, $rev_id);
		$revision = $model->getRevision($budget_id, $rev_id);
		$messages = $model->getMessages($budget_id);

		$type = $model->getType($budget->type_id);
		
		$document = &JFactory::getDocument();

		$title = JText::_('Budget') . ' ' . $budget->id;
		if ($rev_id != 0) $title .= ', ' . JText::_('Revision') . ' ' . $rev_id;
		$title .= ' - ' . JFactory::getUser()->username;
		$title .= ' - ' . $type->title;
		
		$document->setTitle($title);
		if ($verjoomla->RELEASE == '1.5') {
			$document->setName($title);
		}
		
		$document->setDescription($type->description);
		//$document->setMetaData('keywords', $article->metakey);
		
		$pdf .= '<h2>'.JText::_('Information').'</h2>';
		$pdf .= '<table>';
		$pdf .= '<tr></tr>';
		$pdf .= '<tr>';
		$pdf .= '<td width="220">'.JText::_('Title').'</td>';
		$pdf .= '<td width="500">'.$budget->title.'</td>';
		$pdf .= '</tr><tr>';
		$pdf .= '<td width="220">'.JText::_('Description').'</td>';
		$pdf .= '<td width="500">'.$budget->description.'</td>';
		$pdf .= '</tr><tr>';
		$pdf .= '<td width="220">'.JText::_('Budget date').'</td>';
		$pdf .= '<td width="500">'.JHTML::_('date', $budget->upload, JText::_('DATE_FORMAT_LC2')).'</td>';
		$pdf .= '</tr>';
		if ($budget->upload != $revision->upload) {
			$pdf .= '<tr>';
			$pdf .= '<td width="220">'.JText::_('Revision date').'</td>';
			$pdf .= '<td width="500">'.JHTML::_('date', $revision->upload, JText::_('DATE_FORMAT_LC2')).'</td>';
			$pdf .= '</tr>';
		}
		$pdf .= '</table>';
		$pdf .= '<hr>';
		
		$pdf .= '<h2>'.JText::_('Budget').'</h2>';
		$pdf .= '<table>';
		$pdf .= '<tr></tr>';
		$pdf .= '<tr class="head">';
		$pdf .= '<th width="80">'.JText::_('Amount').'</th>';
		$pdf .= '<th width="450">'.JText::_('Item').'</th>';
		$pdf .= '<th width="95" align="right">'.JText::_('Price').'</th>';
		$pdf .= '<th width="95" align="right">'.JText::_('Total').'</th>';
		$pdf .= '</tr><tr></tr>';
		foreach ($elements as $e) { 
			if ($e->element_amount <> 0) {
				$pdf .= '<tr>';
				$pdf .= '<td width="80" align="center">';
				$pdf .= $e->element_amount;
				$pdf .= '</td><td width="450">';
				$pdf .= $e->element_title;
				$pdf .= '</td><td width="95" align="right">';
				if ($e->element_type == "porc") $pdf .= $e->element_price."%";
				else $pdf .= bdgHelperConfig::getCant($e->element_price, $currency, $currency_align);	
				$pdf .= '</td><td width="95" align="right">';
				if ($e->element_type == "porc") $pdf .= $e->element_total."%";
				else $pdf .= bdgHelperConfig::getCant($e->element_total, $currency, $currency_align);				
				$pdf .= '</td>';
				$pdf .= '</tr>';
			}
		}
		$pdf .= '</table>';
		
		$pdf .= '<hr>';
		$pdf .= '<h2>'.JText::_('Total').'</h2>';
		$pdf .= '<table>';
		$pdf .= '<tr></tr>';
		if ($budget->upload != $revision->upload) {
			$pdf .= '<tr>';
			$pdf .= '<td width="640">'.JTEXT::_('Budget Original Total').'</td>';
			$pdf .= '<td width="80" align="right">'.bdgHelperConfig::getCant($budget->price,$currency,$currency_align).'</td>';
			$pdf .= '</tr>';
			$pdf .= '<tr>';
			$pdf .= '</tr>';
		}
		$pdf .= '<tr>';		
		$pdf .= '<td width="640">'.JText::_('Budget Total').'</td>';
		$pdf .= '<td width="80" align="right">'.bdgHelperConfig::getCant($revision->price,$currency,$currency_align).'</td>';
		$pdf .= '</tr>';
		$pdf .= '</table>';
		
		if (count($messages) > 0) {
			$pdf .= '<hr>';
			$pdf .= '<h2>'.JText::_('Comments').'</h2>';
			$pdf .= '<table>';
			foreach ($messages as $m) {
				$pdf .= '<tr></tr><tr>';
				$pdf .= '<td>';
				//$pdf .= print_r($m);
				$pdf .= '<h3>'.$m->title.'</h3>';
				$pdf .= '<h5>'.JHTML::_('date', $m->upload, JText::_('DATE_FORMAT_LC2')).' '.JText::_('by').' '.JFactory::getUser($m->user_id)->username.'</h5>';
				$pdf .= '<sect>'.$m->description.'</sect>';
				$pdf .= '</td>';
				$pdf .= '</tr>';
			}
			$pdf .= '</table>';
		}
		
		//echo $pdf;
		if ($verjoomla->RELEASE == '1.5') {
			echo $pdf;
		} else {

			require_once(JPATH_COMPONENT . DS . 'externals' . DS . 'tcpdf' . DS . 'pdf.php');
			$doc_pdf = new JDocumentPDF();
			$doc =& JFactory::getDocument();
			$doc->setMimeEncoding('application/pdf');

		      $pdf_doc = new TCPDF("P", "mm", "A4", true);
		      $pdf_doc->SetMargins(15,15,15);
		      $pdf_doc->SetAutoPageBreak(TRUE, 10);
		      $pdf_doc->SetFont("vera", "", 11);   
		      $pdf_doc->AddPage();
		      $pdf_doc->WriteHTML($pdf, true);
		      $pdf_doc->Output($title.".pdf", "I"); 
		}
	}
}
?>
